extends Control

signal custom_signal # not recommended any more
signal custom_signal_recommended # this is the recommended way
signal custom_signal_with_argument(arg) # send arguments via signal

func _ready() -> void:
	connect("custom_signal", _on_custom_signal)
	custom_signal_recommended.connect(_on_custom_signal_recommended)
	custom_signal_with_argument.connect(_on_custom_signal_with_argument)

func _on_button_pressed() -> void:
	print("Button pressed")
	emit_signal("custom_signal") # you emit signals via code like this

func _on_custom_signal() -> void:
	print("Custom Signal sent")
	emit_signal("custom_signal_recommended")
	
func _on_custom_signal_recommended() -> void:
	print("Custom Signal Recommended sent")
	emit_signal("custom_signal_with_argument", 1)
	
func _on_custom_signal_with_argument(arg: int) -> void:
	print("Custom Signal with argument '%d' sent" % arg)
